/*
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
~  MCIExt.h                                                             ~
~ Copyright (c) 1992, 1993, 1994, 1995 Crystal Semiconductor Corp.      ~
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/


#ifndef _INC_MCIEXT
#define _INC_MCIEXT
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~ TYPEDEFS ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

											// Enumeration for use with boolean type
											// returns which could also be not available.
enum FUZZBOOL
	{
	FUZZFALSE = FALSE,
	FUZZNA = 0x80,
	FUZZTRUE = TRUE
	};

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~ #DEFINES ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			
#define LOG255	((double) 2.4065 )			

			
#define DRV_GETMCIDEVCAPS		DRV_USER + 1
#define DRV_SELECTINPUT 		DRV_GETMCIDEVCAPS + 1
#define DRV_DESELECTINPUT		DRV_SELECTINPUT	+ 1
#define	DRV_GETSELECTEDINPUTS		DRV_DESELECTINPUT + 1
#define	DRV_GETVOLQUANTA		DRV_GETSELECTEDINPUTS + 1
#define	DRV_EXTSETVOLUME	  	DRV_GETVOLQUANTA + 1
#define	DRV_EXTGETVOLUME	  	DRV_EXTSETVOLUME + 1
#define	DRV_MUTENODE			DRV_EXTGETVOLUME + 1
#define DRV_NODEMUTED			DRV_MUTENODE + 1

											// Capture peak functions.
#define	DRV_OPENPEAKS			DRV_NODEMUTED + 1
#define	DRV_GETPEAKS			DRV_OPENPEAKS + 1
#define	DRV_CLOSEPEAKS			DRV_GETPEAKS + 1
#define DRV_GETDITHERSTATE		DRV_CLOSEPEAKS + 1

											// Control dither state.
#define DRV_SETDITHERSTATE		DRV_GETDITHERSTATE + 1
											// Control record monitor.
#define DRV_SETMONITORMODE		DRV_SETDITHERSTATE + 1
#define DRV_GETMONITORMODE		DRV_SETMONITORMODE + 1
											// Get, Set input boost.
#define DRV_GETBOOSTSTATE		DRV_GETMONITORMODE + 1
#define DRV_SETBOOSTSTATE		DRV_GETBOOSTSTATE + 1

											// Timer control functions.
#define DRV_GETTIMERRES			DRV_SETBOOSTSTATE + 1
#define DRV_GETTIMER			DRV_GETTIMERRES + 1
#define DRV_SETTIMERCALLBACK		DRV_GETTIMER + 1
#define DRV_SETTIMER			DRV_SETTIMERCALLBACK + 1
#define DRV_ENABLETIMER			DRV_SETTIMER + 1
#define DRV_DISABLETIMER		DRV_ENABLETIMER	+ 1
#define DRV_FREETIMER			DRV_DISABLETIMER + 1

#define DRV_GETSHAREDMEMBYTE		DRV_FREETIMER + 1

#define DRV_SETSHAREDMEMBYTE		DRV_GETSHAREDMEMBYTE + 1

										// Command to  save current settings
										// to cs??ba??.ini
#define DRV_SAVESETTINGS		DRV_SETSHAREDMEMBYTE + 1

										// MCI Extension to set tone controls.
										// This is only for use by custom
										// spin-offs.  The base driver has no
										// tone controls.
#define DRV_GETTONE			DRV_SAVESETTINGS + 1
#define DRV_SETTONE			DRV_GETTONE + 1

										// These are controls to get and set
										// the input AGC.												
#define DRV_GET_AGC			DRV_SETTONE + 1
#define DRV_SET_AGC			DRV_GET_AGC + 1

										// Use these messages to register and 
										// unregister for change notification
										// callbacks.
#define DRV_MIX_OPEN			DRV_SET_AGC + 1
#define DRV_MIX_CLOSE			DRV_MIX_OPEN + 1

			   
// !!!! START EXPERIMENTAL !!!!!!
#define DRV_SET_INTRATE			DRV_MIX_CLOSE + 1
#define DRV_GET_INTRATE			DRV_SET_INTRATE + 1
#define DRV_SET_DECAYRATE		DRV_GET_INTRATE + 1
#define DRV_GET_DECAYRATE		DRV_SET_DECAYRATE + 1
#define DRV_SET_AGCTARGET		DRV_GET_DECAYRATE + 1
#define DRV_GET_AGCTARGET		DRV_SET_AGCTARGET + 1
// !!!!! END EXPERIMENTAL !!!!!

	
#define DRV_OPEN_SPEAKERPHONE 		DRV_USER + 100
#define DRV_CLOSE_SPEAKERPHONE		DRV_USER + 101

#define DRV_LOCKMIXER 			DRV_USER + 110
#define DRV_UNLOCKMIXER			DRV_USER + 111

// !!!!! START EXPERIMENTAL !!!!!!
#define DRV_SET_LEFT_TRICKLE		DRV_USER + 200
#define DRV_SET_RIGHT_TRICKLE		DRV_USER + 201
#define DRV_GET_LEFT_TRICKLE		DRV_USER + 202
#define DRV_GET_RIGHT_TRICKLE		DRV_USER + 203

#define DRV_SET_HYBRID_FEEDBACK		DRV_USER + 204
#define DRV_GET_HYBRID_FEEDBACK		DRV_USER + 205

#define DRV_SET_REMOTE_WHEIGHTING	DRV_USER + 206
#define DRV_GET_REMOTE_WHEIGHTING	DRV_USER + 207

#define DRV_GET_VOLTAGE			DRV_USER + 208
//#define DRV_GET_RIGHTENERGY		DRV_USER + 209

#define DRV_SET_SPEAKER_FEEDBACK	DRV_USER + 210
#define DRV_GET_SPEAKER_FEEDBACK	DRV_USER + 211

#define DRV_SET_HYSTERISIS		DRV_USER + 212
#define DRV_GET_HYSTERISIS		DRV_USER + 213

#define DRV_MUTESPEAKERPHONE		DRV_USER + 215
#define DRV_HOLDSPEAKERPHONE		DRV_USER + 216

#define DRV_GETMUTESPEAKERPHONE		DRV_USER + 217
#define DRV_GETHOLDSPEAKERPHONE		DRV_USER + 218

#define DRV_FORCESPEAKERPHONESTATE	DRV_USER + 220

	/*******************************************************************/
	// #defines to describe inputs to the device
	/*******************************************************************/

#define	ID_INPUTMIC    		1
#define	ID_INPUTLINE   		2
#define	ID_INPUTAUX    		3
#define	ID_INPUTLOOPBACK	4

#define  ID_MONITOR     	33

#define ID_AUX1MIXER	   	65
#define	ID_AUX2MIXER		66
#define ID_LINEMIXER		67
#define ID_MONOMIXER		68

#define ID_WAVEOUT      	70
#define	ID_MONOOUT		71

#define ID_VIRTMASTEROUT	80
#define ID_REALMASTEROUT	81

#define ID_ALLINPUTCONTROLS	0x100				// Used to identify all input controls.
#define ID_ALLMIXERCONTROLS	0x200				// Used to identify all mixer controls.
#define ID_ALLCONTROLS		0x400				// Identifies all controls.

												// Controls for custom spins of the
												// driver must be in the range
												// ID_USERCONTROL to ( VOLUME_USECURRSETTINGS - 1 )
#define ID_USERCONTROL		0X0800
												// These are the possible monitor modes.
#define  MON_ALWAYS		1
												// Monitor only while recording or 'VU-ing'.
#define  MON_WHEN_RECORDING	2

	/*******************************************************************/
	/*  This #define is or'ed in with parameters associated with       */
	/*  setting and getting volumes.  If set, this bit will cause      */
	/*  the driver to respond to the command in terms of the number    */
	/*  of possible settings for the volume in question.               */
	/*  For example.  If an input gain has 16 possible settings then   */
	/*  a command to set the gain to possition 8 could be sent by      */
	/*  or'ing in VOLUME_DISCRETEQUANTA with the input selected and    */
	/*  passing 8 as the volume.                                       */
	/*******************************************************************/

#define	VOLUME_DISCRETEQUANTA	(( WORD ) 0X8000 )

	/*******************************************************************/
	/* This flag can be or'ed with the Controls ID when making a       */
	/* call to change the controls volume.  If or'ed the volume        */
	/* will be  'refressed' to the current setting.  This is typically */
	/* used only by the driver to restore volumes after muting or some */
	/* other 'non volume change' volume change.                        */
	/*******************************************************************/
#define VOLUME_USECURRSETTINGS	(( WORD ) 0X4000 )

	/*******************************************************************/
	/* You can or these bits into the Control ID when making           */
	/* mute/unmute calls to effect a change in only one channel.	   */
	/* Currently, this feature is only implemented for the ID_WAVEOUT  */
	/*******************************************************************/

#define EFFECT_LEFT_ONLY_BIT 	(( WORD ) 0x02000 )
#define EFFECT_RIGHT_ONLY_BIT	(( WORD ) 0x01000 )

typedef WORD PeakID;

typedef	struct PeakStructure
	{
	WORD	wLeftPeak;
	BOOL	bLeftClip;
	WORD	wRightPeak;
	BOOL	bRightClip;
	} PeakStructure;


#define MAX_CONTROL_NAME_LEN 16
#define MONO_CONTROL	0
#define STEREO_CONTROL 	1

#define LINEAR_TAPER	0
#define LOG_TAPER	1

typedef struct SliderControl
	{
	BYTE	Name[ MAX_CONTROL_NAME_LEN + 1 ];
	BOOL	bStereoOrMono;
	WORD	wQuantum;
	BOOL	bMutable;
	WORD	wLinearOrLog;
	WORD	wID;	
	} SliderControl;

typedef struct	MCIExtDevCaps
	{
	WORD	wNumInputs;
	SliderControl FAR *lpInputs;

	WORD 	wNumMonitors;
	SliderControl FAR *lpMonitors;

	WORD	wNumMasters;
	SliderControl FAR *lpMasters;

	} MCIExtDevCaps;


typedef struct MixerOpenStruct
	{
							// Driver Instances of this structure use this field
							// to manage the structures.
	struct MixerOpenStruct FAR *pNext;

	DWORD dwCallback;		// A pointer to a callback thunk.
	DWORD dwFlags;			// Not used.
							// CALLBACK_FUNCTION if dwCallback is a pointer to a  function.
	DWORD dwInstData;		// Data to be passed back to client if using a callback function.
	} MixerOpenStruct;


							// lParam 1 of the DRV_OPEN_SPEAKERPHONE is a far pointer
							// to a SpeakerPhoneOpenStruct.

typedef struct SpeakerPhoneOpenStruct
	{

	DWORD WaveOutCallback;		// A pointer to a callback routine or a window handle.
	DWORD WaveInCallback;		// A pointer to a callback routine or a window handle.
	DWORD dwFlags;				// Indicates callback is a routine or window handle.
	DWORD dwSamplesPerSecond;	// The sample rate for Wave Out and In.

	} SpeakerPhoneOpenStruct;



#define SF_MICAGC		0X01
#define SF_SIMPLEX		0X02	// If neither simplex or duplex flag is set then
#define SF_DUPLEX		0X04	// headphone mode is implied.
#define SF_CALLMONITOR 0X08    // Used for call monitoring.
#define SF_ACTIVE		0X10	// Used internally by the driver.
#define SF_MUTED		0X20    // Used internally by the driver.
#define SF_ONHOLD		0X40    // Used internally by the driver.
#define SF_CAL			0X80    // Used internally by the driver.

                                // The  application has responsibility for connecting
                                // the modem to the CODEC.
#define SF_APP_CONECTMODEM  0X100


#define GV_LEFTBATT	0X00
#define GV_RIGHTBATT	0X01
#define GV_LEFTNOISE	0X02
#define GV_RIGHTNOISE	0X03

#define SS_REMOTE		0
#define SS_LOCAL		1
#define SS_AUTO			2

#endif 	// _INC_MCIEXT


/*
 *   Karaoke extensions
 */

//----------  Messages to driver through sent via                ----------
//            LRESULT SendDriverMessage(hDriver,CRYSTAL_MSG,lParam1,lParam2);

      // DRV_GETKARAOKEMODES
      // lParam1 is a pointer to a DWORD that the driver fills with karaoke
      // mode data. The high word returned will contain a bitmap of supported 
      // states, the low word returned will contain a bitmap of currently
      // selected states (so far, these are exclusive, so exactly one bit
      // will be set).
      // lParam2 is unused.
#define DRV_GETKARAOKEMODES  DRV_USER+300

      // DRV_SETKARAOKEMODES
      // The low word of lParam1 is a bitmap of the mode(s) to be set. If
      // this is impossible (if two modes that are mutually exclusive are 
      // set, etc.) the modes are not changed.
      // lParam2 is unused.
#define DRV_SETKARAOKEMODES  DRV_GETKARAOKEMODES+1

      // DRV_GETKARAOKEMODENAME
      // The low word of lParam1 is a bitmap of the modes, with exactly one
      // bit set.
      // lParam2 is a pointer to a DWORD which the driver fills with a
      // pointer to a null-terminated string (in the driver memory space) that
      // describes the mode selected. This must be copied to the application's
      // memory space if it is to be modified, etc.
      // If the bitmap is invalid or there is no string available for the
      // selected mode, NULL is returned.
#define DRV_GETKARAOKEMODENAME  DRV_SETKARAOKEMODES+1

// ---------  Karaoke modes used for bitmap arguments         ----------
// Currently exactly one bit must be on when selecting a mode. If future
// extensions allow simultaneous modes, OR these values to obtain a bitmap.
// The high word returned by GET_KARAOKEMODES will contain all available modes
// OR'd together (0 if no modes are supported)

#define KAR_OFF      0x01
#define KAR_RECORD   0x02
#define KAR_NORECORD 0x04

/* eof */

